String image_source="200_s.gif"; // le nom de l'image à placer dans le dossier

import processing.sound.*;

TriOsc triOsc;
Env env;
piximage i;
int trigger;

// Times and levels for the ASR envelope
float attackTime = 0.001;
float sustainTime = 0.004;
float sustainLevel = 0.2;
float releaseTime = 0.1;


int duration = 100;
int note_minimale=20;
int note_maximale=100;

void setup() {
  size(700, 700);
  i=new piximage(image_source, 10, 10, width-20, height-20);
  triOsc = new TriOsc(this);

  // Create the envelope 
  env  = new Env(this); 
  trigger = millis();
}

void draw() {
  if (millis() > trigger) {
    background(0);
    i.afficher();
    i.next_pix();

    int note=int(map(i.bleu+i.vert+i.rouge, 0, 755, note_minimale, note_maximale));
    
    // le volume déterminé par la quantité de bleu
    float volume=map(i.bleu, 0, 255, 0, 1);


    triOsc.play(midiToFreq(note), volume);
    // The envelope gets triggered with the oscillator as input and the times and levels we defined earlier
    env.play(triOsc, attackTime, sustainTime, sustainLevel, releaseTime);


    affiche_stats(20, 200);
    trigger = millis() + duration;
  }
}

float midiToFreq(int note) {
  return (pow(2, ((note-69)/12.0)))*440;
}